#include <stdlib.h>
#include <math.h>
#include <stdio.h>

#define INF 1000000

struct Polda {
  int x;
  int y;
};
typedef struct Polda polda;
struct Primka {
  double q;
  double c;
  polda a;
  polda b;
};
typedef struct Primka primka;

polda pol[1000];
primka line[100000];
polda pompol[100];

int comp1(primka *p, primka *q) {
  if ( fabs(p->q - q->q) < 1/INF )
    return (p->c - q->c);
  return (p->q - q->q);
}

int comp2(polda *a, polda *b) {
  if (a->x == b->x)
    return (a->y - b->y);
  return (a->x - b->x);
}



int main () {
  int x, y, i, j, n;
  int pl;
  int a, b, ko;

  while (1) {  
    j = 0;
    do {
      i = scanf("%d %d", &x, &y);
      pol[j].x = x;
      pol[j].y = y;
      j++;
    } while ( i > -1 && (x || y) ) ;

    if (j==1) break;
    n = j-1;

    pl = 0;
    for (i=0; i<n; i++)
      for (j=i+1; j<n; j++) {
        if (pol[i].x == pol[j].x) { 
          line[pl].q = INF;
          line[pl].c = pol[i].x;
        } else {
          line[pl].q = ((double) (pol[i].y - pol[j].y)) / (pol[i].x - pol[j].x);
          line[pl].c = pol[i].y - pol[i].x * line[pl].q;
        }
        line[pl].a.x = pol[i].x;
        line[pl].a.y = pol[i].y;
        line[pl].b.x = pol[j].x;
        line[pl].b.y = pol[j].y;
        pl++;
      }

    qsort (line, pl, sizeof(primka), &comp1);

    for (i=0; i<pl; i++)
      printf("%f %f\n", line[i].q, line[i].c);

    ko = 0;
    for (a=0; a<pl; a++) {
      for (b=a+1; b<pl; b++)
        if (comp1(&line[a], &line[b]) )  break;
      j = b-a;
      if (j>2) {
        if (!ko) {
          printf("Tito policiste porusuji smernici:\n");
          ko = 1;
        }
        for (i=0; i<j; i++)
          pompol[i] = pol[a+i];
        qsort(pompol, j, sizeof(polda), &comp2);

        for (i=0; i<j; i++)
          if (i==0 || comp2(&pol[i], &pol[i-1]) )
            printf("(%d,%d)", pol[i].x, pol[i].y);
        printf("\n");
      }
      a = b-1;
    }
    if (!ko) printf("Smernice byla dodrzena.\n");
    printf("\n");
  }
  return 0;
}
